include misc.e
include get.e
include file.e
include image.e
include graphics.e
include BugBrain.e

constant
  LAND       = '',
  TREE       =  5,
  LANDCOLOR  =  2,
  TREECOLOR  = 10

sequence buginfo buginfo=repeat(0,6)
sequence bugqns  bugqns ={{1,1,4},{1,1,5},{1,1,6},
			 { 2,1,4},{2,1,5},{2,1,6},
			 { 3,1,4},{3,1,5},{3,1,6}}
integer  maxbugchoices maxbugchoices=4  --leftahead,ahead,rightahead,turnleft
sequence world     world=repeat(repeat(0,18),18)
integer  INK       INK  =0
integer  rx,ry
integer  direction direction=1
sequence BUGTABLE  BUGTABLE =repeat(repeat(0,length(bugqns)+1),maxbugchoices)
sequence bug       bug      ={0,0,0,0}
constant
   YLOC   = 1,
   XLOC   = 2,
   DLTY   = 3,   --delta y
   DLTX   = 4

sequence binary_pattern binary_pattern=repeat(0,length(bugqns)+1)
integer  bugchoice bugchoice=1
atom     bugscore  bugscore =0
integer  turns     turns    =0
atom     tscore    tscore   =0
--integer  rness     rness    =500    --randomness
--atom     anealrate anealrate=1 --.999 --just a guess
constant
   FOOD   = '+',
   NBUG   = 'A',
   WBUG   = '<',
   SBUG   = 'V',
   EBUG   = '>',
   BUG    = 'X'

constant
  FOODCOLOR= 15,
  BUGCOLOR =  0

procedure make_map()
  bk_color(7)
  clear_screen()
  text_color(5)
  position(1,1) puts(1,"  THE BUG'S WORLD BINARY INPUT PATTERN   THE WEIGHT MATRIX")
  bk_color(3)
  text_color(6)
  position( 2,21) puts(1," LEFT TREE ?")
  position( 3,21) puts(1,"      EMPTY?")
  position( 4,21) puts(1,"      FOOD ?")
  position( 5,21) puts(1,"AHEAD TREE ?")
  position( 6,21) puts(1,"      EMPTY?")
  position( 7,21) puts(1,"      FOOD ?")
  position( 8,21) puts(1,"RIGHT TREE ?")
  position( 9,21) puts(1,"      EMPTY?")
  position(10,21) puts(1,"      FOOD ?")
  position(11,21) puts(1," BIAS VALUE ")
  bk_color(2)
  text_color(7)
  position(12,25) puts(1,"COLUMN TOTALS")
  bk_color(3)
  text_color(6)
  position(14,19) puts(1,"BINARY OUPUT PATTERN")
  position(15,42) puts(1,"LEFT AHEAD RIGHT TURN")
  text_color(0)
  position(21,50) puts(1,"CHANGE SPEED WITH UP/DOWN KEYS")
  position(23,35) puts(1,"PRESS ESC TO QUIT")
  bk_color(LANDCOLOR)
  text_color(TREECOLOR)
  for x=1 to 18 do
    for y=1 to 18 do
      position(y+1,x) puts(1,TREE)         world[y][x]=TREE
    end for
  end for
  text_color(LANDCOLOR)
  for x=2 to 17 do
    for y=2 to 17 do
      position(y+1,x) puts(1,LAND)          world[y][x]=LAND
    end for
  end for
  text_color(TREECOLOR)
  for x=1 to 45 do
    rx=rand(16)+1
    ry=rand(16)+1
    position(ry+1,rx)
    puts(1,TREE)
    world[ry][rx]=TREE
  end for
end procedure

procedure make_nmls()
  text_color(FOODCOLOR)
  for k=1 to 35 do
    rx=rand(16)+1
    ry=rand(16)+1
    position(ry+1,rx)
    puts(1,FOOD)
    world[ry][rx]=FOOD
  end for
  text_color(BUGCOLOR)
  rx=rand(16)+1
  ry=rand(16)+1
  position(ry+1,rx)
  puts(1,NBUG)
  world[ry][rx]=BUG
  bug[YLOC] = ry
  bug[XLOC] = rx
end procedure

procedure set_binary_pattern()
  binary_pattern*=0
  for a=1 to length(bugqns) do
    if buginfo[bugqns[a][1]]=buginfo[bugqns[a][3]] then
      binary_pattern[a]=1
    end if
  bk_color(6)
  text_color(0)
  position(a+1,36) printf(1,"%d",binary_pattern[a])
  end for
  binary_pattern[length(bugqns)+1]=1 --BIAS VALUE
  position(length(bugqns)+1+1,36) printf(1,"%d",binary_pattern[length(bugqns)+1])
end procedure

procedure set_buginfo()
  text_color(9)
  if direction=1 then
    buginfo[1]=world[bug[YLOC]-1][bug[XLOC]-1]
    buginfo[2]=world[bug[YLOC]-1][bug[XLOC]  ]
    buginfo[3]=world[bug[YLOC]-1][bug[XLOC]+1]
  end if
  if direction=2 then
    buginfo[1]=world[bug[YLOC]+1][bug[XLOC]-1]
    buginfo[2]=world[bug[YLOC]  ][bug[XLOC]-1]
    buginfo[3]=world[bug[YLOC]-1][bug[XLOC]-1]
  end if
  if direction=3 then
    buginfo[1]=world[bug[YLOC]+1][bug[XLOC]+1]
    buginfo[2]=world[bug[YLOC]+1][bug[XLOC]  ]
    buginfo[3]=world[bug[YLOC]+1][bug[XLOC]-1]
  end if
  if direction=4 then
    buginfo[1]=world[bug[YLOC]-1][bug[XLOC]+1]
    buginfo[2]=world[bug[YLOC]  ][bug[XLOC]+1]
    buginfo[3]=world[bug[YLOC]+1][bug[XLOC]+1]
  end if
  buginfo[4]=TREE
  buginfo[5]=LAND
  buginfo[6]=FOOD
  set_binary_pattern()
end procedure

object t t=1

procedure bug_move()
  set_buginfo()
  bugchoice=Patrec_choose(binary_pattern,BUGTABLE)
  bk_color(LANDCOLOR)
  text_color(BUGCOLOR)

  bugscore=0
  if bugchoice=1 then
    if direction=1 then bug[DLTY]=-1 bug[DLTX]=-1  end if
    if direction=2 then bug[DLTY]=+1 bug[DLTX]=-1  end if
    if direction=3 then bug[DLTY]=+1 bug[DLTX]=+1  end if
    if direction=4 then bug[DLTY]=-1 bug[DLTX]=+1  end if end if
  if bugchoice=2 then
    if direction=1 then bug[DLTY]=-1 bug[DLTX]= 0  end if
    if direction=2 then bug[DLTY]= 0 bug[DLTX]=-1  end if
    if direction=3 then bug[DLTY]=+1 bug[DLTX]= 0  end if
    if direction=4 then bug[DLTY]= 0 bug[DLTX]=+1  end if end if
  if bugchoice=3 then
    if direction=1 then bug[DLTY]=-1 bug[DLTX]=+1  end if
    if direction=2 then bug[DLTY]=-1 bug[DLTX]=-1  end if
    if direction=3 then bug[DLTY]=+1 bug[DLTX]=-1  end if
    if direction=4 then bug[DLTY]=+1 bug[DLTX]=+1  end if end if
  if bugchoice=4 then  bugscore=-1
    if direction=1 then
      if world[bug[YLOC]-1][bug[XLOC]-1]=TREE then --only turn if three trees
	if world[bug[YLOC]-1][bug[XLOC]  ]=TREE then
	  if world[bug[YLOC]-1][bug[XLOC]+1]=TREE then
	    bugscore=1
	  end if
	end if
      end if
    end if
    if direction=2 then
      if world[bug[YLOC]+1][bug[XLOC]-1]=TREE then
	if world[bug[YLOC]  ][bug[XLOC]-1]=TREE then
	  if world[bug[YLOC]-1][bug[XLOC]-1]=TREE then
	    bugscore=1
	  end if
	end if
      end if
    end if
    if direction=3 then
      if world[bug[YLOC]+1][bug[XLOC]-1]=TREE then
	if world[bug[YLOC]+1][bug[XLOC]  ]=TREE then
	  if world[bug[YLOC]+1][bug[XLOC]+1]=TREE then
	    bugscore=1
	  end if
	end if
      end if
    end if
    if direction=4 then
      if world[bug[YLOC]-1][bug[XLOC]+1]=TREE then
	if world[bug[YLOC]  ][bug[XLOC]+1]=TREE then
	  if world[bug[YLOC]+1][bug[XLOC]+1]=TREE then
	    bugscore=1
	  end if
	end if
      end if
    end if
    direction+=1
    if direction=5 then direction=1 end if
    bug[DLTY]= 0 bug[DLTX]= 0
    position(bug[YLOC]+1,bug[XLOC])
    text_color(BUGCOLOR)
    if direction=1 then puts(1,NBUG) end if
    if direction=2 then puts(1,WBUG) end if
    if direction=3 then puts(1,SBUG) end if
    if direction=4 then puts(1,EBUG) end if
  end if
  if world[bug[YLOC]+bug[DLTY]][bug[XLOC]+bug[DLTX]]=LAND then
     world[bug[YLOC]][bug[XLOC]]=LAND --put grass back
     position(bug[YLOC]+1,bug[XLOC])
     text_color(LANDCOLOR)
     puts(1,LAND)
     bug[YLOC]+=bug[DLTY]
     bug[XLOC]+=bug[DLTX]
     world[bug[YLOC]][bug[XLOC]]=BUG
     position(bug[YLOC]+1,bug[XLOC])
     text_color(BUGCOLOR)
     if direction=1 then puts(1,NBUG) end if
     if direction=2 then puts(1,WBUG) end if
     if direction=3 then puts(1,SBUG) end if
     if direction=4 then puts(1,EBUG) end if
     bugscore=-.1  --a very small negative value (means he gets hungry?)
		   --helps get out of ruts
  elsif world[bug[YLOC]+bug[DLTY]][bug[XLOC]+bug[DLTX]]=TREE   then bugscore=-1
  elsif world[bug[YLOC]+bug[DLTY]][bug[XLOC]+bug[DLTX]]=FOOD then
    world[bug[YLOC]][bug[XLOC]]=LAND --put grass back
    position(bug[YLOC]+1,bug[XLOC])
    text_color(LANDCOLOR)
    puts(1,LAND)
    bug[YLOC]+=bug[DLTY]
    bug[XLOC]+=bug[DLTX]
    world[bug[YLOC]][bug[XLOC]]=BUG
    position(bug[YLOC]+1,bug[XLOC])
    text_color(BUGCOLOR)
     if direction=1 then puts(1,NBUG) end if
     if direction=2 then puts(1,WBUG) end if
     if direction=3 then puts(1,SBUG) end if
     if direction=4 then puts(1,EBUG) end if
    bugscore=1
    rx=rand(16)+1
    ry=rand(16)+1
    while world[ry][rx]!=LAND do --otherwise they begin to disappear
      rx=rand(16)+1
      ry=rand(16)+1
    end while

    text_color(FOODCOLOR)
    position(ry+1,rx)
    puts(1,FOOD)
    world[ry][rx]=FOOD
  end if
--  bugscore*=anealrate
--  anealrate*=.99
  bk_color(5)
  text_color(14)
  position(2,65) printf(1,"score  %4.1f",bugscore)
  tscore+=bugscore
  position(3,65) printf(1,"total  %4.1f",tscore)

  BUGTABLE=Patrec_learn(binary_pattern,BUGTABLE,bugchoice,bugscore)

end procedure

make_map()
make_nmls()
atom delay delay=.2
while INK!=27 do
  bug_move()
  INK=get_key()
  position(20,60) printf(1,"delay  %3.1f seconds",delay)
  if INK=328 then
    delay+=.1
  end if
  if INK=336 then
    delay-=.1
    if delay<0 then
      delay=0
    end if
  end if

    t=time()+delay
    while time()<t do end while

  turns+=1
  text_color(14)
  bk_color(5)
  position(1,65) printf(1,"Turns %5d",turns)
end while
if graphics_mode(-1) then
end if

